# ───────────────────────────────────────────────────────────────────────────────
# wallpaper.nu — THE MOST REDPILLED WALLPAPER SCRIPT ON PLANET EARTH
# IF YOU'RE NOT USING NUSHELL, CLOSE THIS FILE AND GO INSTALL WINDOWS 11, NPC
# ───────────────────────────────────────────────────────────────────────────────

# SHOVE YOUR MINIO CREDS STRAIGHT INTO THE ENV — NO PROMPTING, NO SANITIZING, RAW-DOGGED INTO MEMORY
$env.MINIO_HOST   = "simxnet.andremor.eu.org:9000"
$env.BUCKET       = "wallpapers"
$env.MINIO_KEY    = "" # BASED BUT UNNECESSARY
$env.MINIO_SECRET = "" # BASED BUT UNNECESSARY

# USE TMPDIR IF IT EXISTS, OTHERWISE WE GO FERAL AND DUMP INTO /tmp LIKE A REAL UNIX DEMON
let temp_dir = ($env.TMPDIR | default "/tmp")

# DECLARE WAR AGAINST DEFAULT WALLPAPERS — SUMMON GIGACHAD ENDPOINT VIA mc
# IF YOU'RE CRYING ABOUT SELF-SIGNED CERTS, GO BACK TO GNOME EXTENSIONS
do {
    mc alias set --insecure gigachad $"https://($env.MINIO_HOST)" $env.MINIO_KEY $env.MINIO_SECRET
} catch {
    echo "❌ COULDN'T SETUP mc — INSTALL IT, OR ACCEPT YOUR ROLE AS A TERMINAL TOURIST"
    exit 1
}

# PILLAGE THE BUCKET LIKE A RAIDING PARTY — LIST ALL OBJECTS, LEAVE NOTHING
let raw_list = (mc find $"gigachad/($env.BUCKET)" | lines)

# FILTER OUT USELESS FOLDER PHANTOMS — WE ONLY DEAL IN FILES, NOT YOUR GRANDMA'S EMPTY PHOTO ALBUM
let all_files = (
  $raw_list
  | filter {|line| not ($line | str ends-with "/") }
)

# IF YOU GOT NO FILES, YOUR BUCKET IS A WASTELAND — FILL IT OR COPE
if ($all_files | length) == 0 {
    echo "❌ BUCKET EMPTY — NO WALLPAPERS, NO BITCHES"
    exit 1
}

# SUMMON ONE RANDOM FILE — ROLL THE GACHA, HOPE FOR PEAK PIXEL PERFECTION
let random_object = ($all_files | shuffle | first)

# EXTRACT THE FILE NAME AND BUILD THE SACRED LOCAL DOWNLOAD PATH
let filename   = ($random_object | path basename)
let local_path = $"($temp_dir)/($filename)"

# YOINK THE FILE FROM MINIO LIKE IT'S THE LAST FUCKING JPEG ON EARTH
echo "🎯 SELECTED: $random_object"
echo "📥 DOWNLOADING TO: $local_path"
do {
    mc cp $random_object $local_path
} catch {
    echo "❌ DOWNLOAD FAILED — PROBABLY A SKILL ISSUE"
    exit 1
}

# SLAM THAT WALLPAPER INTO SWWW AND LET THE VIBES ASCEND TO HEAVEN
echo "🖼️ BLASTING WALLPAPER INTO EXISTENCE WITH SWWW — BRACE FOR VISUAL EUPHORIA"
do {
    swww img $local_path
} catch {
    echo "❌ SWWW CHOKED HARD — CHECK IF YOU EVEN STARTED THE DAEMON, NPC"
    exit 1
}

echo "✅ WALLPAPER LOCKED, LOADED, AND BASED: $local_path"

